function proxy(worker, methods) {
    var c = 0;
    var callbacks = {};
    worker.addEventListener('message', function (e) {
        var d = e.data;
        if (d.type !== 'RPC') 
            { return; }
        if (d.id) {
            var f = callbacks[d.id];
            if (f) {
                delete callbacks[d.id];
                if (d.error) {
                    if (d.error.stack) {
                        d.error = Object.assign(Error(d.error.message), d.error);
                    }
                    f[1](d.error);
                } else {
                    f[0](d.result);
                }
            }
        } else {
            var evt = document.createEvent('Event');
            evt.initEvent(d.method, false, false);
            evt.data = d.params;
            worker.dispatchEvent(evt);
        }
    });
    return new Proxy(worker, {
        get: function (target, method) {
            if (target[method]) {
                var obj = target[method];
                return typeof obj === 'function' ? target[method].bind(target) : obj;
            } else {
                return new Proxy(function () {}, {
                    apply: function (target, thisArg, params) {
                        return new Promise(function (a, b) {
                            var id = ++c;
                            callbacks[id] = [a,b];
                            worker.postMessage({
                                type: 'RPC',
                                id: id,
                                method: method,
                                params: params
                            });
                        });
                    }
                });
            }
        }
    });
}

module.exports = proxy;
//# sourceMappingURL=rpc-wrapper.js.map
